#!/usr/bin/tclsh

# Register the package
package provide simple-template 1.0
package require Tcl             8.4

# Create the namespace
namespace eval ::simple-template {
	# Export commands
	namespace export parse
}

# parse method

proc ::simple-template::parse {txt} {
	set code "set res {}\n"
        while {[set i [string first <% $txt]] != -1} {
                incr i -1
                append code "append res [list [string range $txt 0 $i]]\n"
                set txt [string range $txt [expr {$i + 3}] end]
                if {[string index $txt 0] eq "="} {
                        append code "append res "
                        set txt [string range $txt 1 end]
                }
                if {[set i [string first %> $txt]] == -1} {
                        error "No matching %>"
                }
                incr i -1
                append code "[string range $txt 0 $i] \n"
                set txt [string range $txt [expr {$i + 3}] end]
        }
        if {$txt ne ""} { append code "append res [list $txt]\n" }
        return $code
}
