#!/usr/bin/env tclsh

if {$argc < 6 || $argc > 8} {
	puts "Usage: -t \[result type; station or normal or sd or all\] -s \[source file\] or -d \[source folder\]  -m \[template folder\]" 
} else {

	# should do further checks but cant be bothered..

	global arglist
	set stationList -1


	set i 1
	set key ""

	foreach item $argv {
		
		if {[expr {$i % 2}] == 0} {
			set arglist($key) $item
		} else {
			set key $item
		}
		incr i
	}

	source station-file-parser.tcl
	
	if {[info exist arglist(-d)] > 0} then {
		set contents [glob -directory $arglist(-d) *]
    		foreach file $contents {

			set stationList [concat $stationList [station-file-parser::parseSingleStation $file $arglist(-m) $arglist(-t)]]
			
			
			
       		}
	} else {

		station-file-parser::parseSingleStation $file $arglist(-m) $arglist(-t)

	}
    	
    if {$arglist(-t) == "all"} then {
		source CRUTEM-file-parser.tcl
		CRUTEM-file-parser::parseCRUTEM "CRUTEM3.dat" $arglist(-m) $stationList
	}

	
	
}
